import "./cljs_env.js";
goog.provide('nextjournal.clojure_mode.util');
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
nextjournal.clojure_mode.util.user_event_annotation = (function nextjournal$clojure_mode$util$user_event_annotation(event_name){
return module$node_modules$$codemirror$state$dist$index_cjs.Transaction.userEvent.of(event_name);
});
nextjournal.clojure_mode.util.get_user_event_annotation = (function nextjournal$clojure_mode$util$get_user_event_annotation(tr){
return tr.annotation(module$node_modules$$codemirror$state$dist$index_cjs.Transaction.userEvent);
});
nextjournal.clojure_mode.util.guard = (function nextjournal$clojure_mode$util$guard(x,f){
if(cljs.core.truth_((f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(x) : f.call(null,x)))){
return x;
} else {
return null;
}
});
nextjournal.clojure_mode.util.from_to = (function nextjournal$clojure_mode$util$from_to(p1,p2){
if((p1 > p2)){
return ({"from": p2, "to": p1});
} else {
return ({"from": p1, "to": p2});
}
});
/**
 * If passed a transaction, dispatch to view and return true to stop processing commands.
 */
nextjournal.clojure_mode.util.dispatch_some = (function nextjournal$clojure_mode$util$dispatch_some(view,tr){
if(cljs.core.truth_(tr)){
view.dispatch(tr);

return true;
} else {
return false;
}
});
/**
 * Returns a `change` that inserts string `s` at position `from` and moves cursor to end of insertion.
 */
nextjournal.clojure_mode.util.insertion = (function nextjournal$clojure_mode$util$insertion(var_args){
var G__80256 = arguments.length;
switch (G__80256) {
case 2:
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$2 = (function (from,s){
return nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3(from,from,s);
}));

(nextjournal.clojure_mode.util.insertion.cljs$core$IFn$_invoke$arity$3 = (function (from,to,s){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"insert","insert",1286475395),s,new cljs.core.Keyword(null,"from","from",1815293044),from,new cljs.core.Keyword(null,"to","to",192099007),to], null),new cljs.core.Keyword(null,"cursor","cursor",1011937484),(from + ((s).length))], null);
}));

(nextjournal.clojure_mode.util.insertion.cljs$lang$maxFixedArity = 3);

nextjournal.clojure_mode.util.deletion = (function nextjournal$clojure_mode$util$deletion(var_args){
var G__80301 = arguments.length;
switch (G__80301) {
case 1:
return nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$1 = (function (from){
return nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$2((function (){var x__4306__auto__ = (0);
var y__4307__auto__ = (from - (1));
return ((x__4306__auto__ > y__4307__auto__) ? x__4306__auto__ : y__4307__auto__);
})(),from);
}));

(nextjournal.clojure_mode.util.deletion.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
var from__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(from,to))?(function (){var x__4306__auto__ = (0);
var y__4307__auto__ = (from - (1));
return ((x__4306__auto__ > y__4307__auto__) ? x__4306__auto__ : y__4307__auto__);
})():from);
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),from__$1,new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"from","from",1815293044),from__$1,new cljs.core.Keyword(null,"to","to",192099007),to], null)], null);
}));

(nextjournal.clojure_mode.util.deletion.cljs$lang$maxFixedArity = 2);

nextjournal.clojure_mode.util.line_content_at = (function nextjournal$clojure_mode$util$line_content_at(state,from){
var obj__49512__auto__ = (function (){var parent__49521__auto__ = (state["doc"]);
var f__49522__auto__ = (parent__49521__auto__["lineAt"]);
return f__49522__auto__.call(parent__49521__auto__,from);
})();
var f__49513__auto__ = (obj__49512__auto__["slice"]);
return f__49513__auto__.call(obj__49512__auto__);
});
nextjournal.clojure_mode.util.map_cursor = (function nextjournal$clojure_mode$util$map_cursor(original_range,state,update_map){
if(cljs.core.map_QMARK_(update_map)){
} else {
throw (new Error("Assert failed: (map? update-map)"));
}

var map__80308 = nextjournal.clojure_mode.util.guard(update_map,cljs.core.map_QMARK_);
var map__80308__$1 = cljs.core.__destructure_map(map__80308);
var mapped = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80308__$1,new cljs.core.Keyword("cursor","mapped","cursor/mapped",1625530272));
var cursor = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80308__$1,new cljs.core.Keyword(null,"cursor","cursor",1011937484));
var from_to = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80308__$1,new cljs.core.Keyword(null,"from-to","from-to",-640428401));
var range = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80308__$1,new cljs.core.Keyword(null,"range","range",1639692286));
var changes = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80308__$1,new cljs.core.Keyword(null,"changes","changes",1492088));
var change_desc = (cljs.core.truth_(changes)?state.changes(cljs.core.clj__GT_js(changes)):null);
var G__80309 = ({"range": (function (){var or__4223__auto__ = range;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
var or__4223__auto____$1 = (cljs.core.truth_(mapped)?nextjournal.clojure_mode.selections.cursor(change_desc.mapPos(mapped)):(cljs.core.truth_(cursor)?nextjournal.clojure_mode.selections.cursor(cursor):(cljs.core.truth_(from_to)?nextjournal.clojure_mode.selections.range.cljs$core$IFn$_invoke$arity$2((from_to.cljs$core$IFn$_invoke$arity$1 ? from_to.cljs$core$IFn$_invoke$arity$1((0)) : from_to.call(null,(0))),(from_to.cljs$core$IFn$_invoke$arity$1 ? from_to.cljs$core$IFn$_invoke$arity$1((1)) : from_to.call(null,(1)))):null)));
if(cljs.core.truth_(or__4223__auto____$1)){
return or__4223__auto____$1;
} else {
return original_range;
}
}
})()});
if(cljs.core.truth_(change_desc)){
var obj80320 = G__80309;
(obj80320["changes"] = change_desc);

return obj80320;
} else {
return G__80309;
}
});
/**
 * Applies `f` to each range in `state` (see `changeByRange`)
 */
nextjournal.clojure_mode.util.update_ranges = (function nextjournal$clojure_mode$util$update_ranges(var_args){
var G__80324 = arguments.length;
switch (G__80324) {
case 2:
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$2 = (function (state,f){
return nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,null,f);
}));

(nextjournal.clojure_mode.util.update_ranges.cljs$core$IFn$_invoke$arity$3 = (function (state,tr_specs,f){
return state.update((function (p1__80322_SHARP_){
return applied_science.js_interop.extend_BANG_.cljs$core$IFn$_invoke$arity$2(p1__80322_SHARP_,tr_specs);
})(state.changeByRange((function (range){
var or__4223__auto__ = (function (){var temp__5757__auto__ = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(range) : f.call(null,range));
if((temp__5757__auto__ == null)){
return null;
} else {
var result = temp__5757__auto__;
return nextjournal.clojure_mode.util.map_cursor(range,state,result);
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return ({"range": range});
}
}))));
}));

(nextjournal.clojure_mode.util.update_ranges.cljs$lang$maxFixedArity = 3);

nextjournal.clojure_mode.util.dispatch_changes = (function nextjournal$clojure_mode$util$dispatch_changes(state,dispatch,changes){
if(cljs.core.truth_(changes.empty)){
return null;
} else {
var G__80328 = state.update(({"changes": changes}));
return (dispatch.cljs$core$IFn$_invoke$arity$1 ? dispatch.cljs$core$IFn$_invoke$arity$1(G__80328) : dispatch.call(null,G__80328));
}
});
nextjournal.clojure_mode.util.update_lines = (function nextjournal$clojure_mode$util$update_lines(var_args){
var args__4835__auto__ = [];
var len__4829__auto___80698 = arguments.length;
var i__4830__auto___80699 = (0);
while(true){
if((i__4830__auto___80699 < len__4829__auto___80698)){
args__4835__auto__.push((arguments[i__4830__auto___80699]));

var G__80700 = (i__4830__auto___80699 + (1));
i__4830__auto___80699 = G__80700;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((2) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((2)),(0),null)):null);
return nextjournal.clojure_mode.util.update_lines.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4836__auto__);
});

(nextjournal.clojure_mode.util.update_lines.cljs$core$IFn$_invoke$arity$variadic = (function (state,f,p__80344){
var vec__80345 = p__80344;
var map__80348 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__80345,(0),null);
var map__80348__$1 = cljs.core.__destructure_map(map__80348);
var from = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__80348__$1,new cljs.core.Keyword(null,"from","from",1815293044),(0));
var to = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80348__$1,new cljs.core.Keyword(null,"to","to",192099007));
var spec = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__80348__$1,new cljs.core.Keyword(null,"spec","spec",347520401));
var iterator = state.doc.iter();
var result = iterator.next();
var changes = [];
var from_pos = from;
var line_num = (1);
while(true){
var map__80370 = result;
var map__80370__$1 = (((((!((map__80370 == null))))?(((((map__80370.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80370.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80370):map__80370);
var done = (function (){var obj80373 = map__80370__$1;
var k80374 = "done";
if((function (){var obj80375 = obj80373;
return (((!((obj80375 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80374,obj80375)));
})()){
return (obj80373[k80374]);
} else {
return undefined;
}
})();
var lineBreak = (function (){var obj80376 = map__80370__$1;
var k80377 = "lineBreak";
if((function (){var obj80378 = obj80376;
return (((!((obj80378 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80377,obj80378)));
})()){
return (obj80376[k80377]);
} else {
return undefined;
}
})();
var value = (function (){var obj80379 = map__80370__$1;
var k80380 = "value";
if((function (){var obj80381 = obj80379;
return (((!((obj80381 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80380,obj80381)));
})()){
return (obj80379[k80380]);
} else {
return undefined;
}
})();
if(cljs.core.truth_((function (){var or__4223__auto__ = done;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return (from > to);
}
})())){
return state.update(applied_science.js_interop.extend_BANG_.cljs$core$IFn$_invoke$arity$2(({"changes": state.changes(changes)}),spec));
} else {
var G__80701 = iterator.next();
var G__80702 = (function (){var temp__5751__auto__ = (function (){var and__4221__auto__ = cljs.core.not(lineBreak);
if(and__4221__auto__){
return (f.cljs$core$IFn$_invoke$arity$3 ? f.cljs$core$IFn$_invoke$arity$3(from_pos,value,line_num) : f.call(null,from_pos,value,line_num));
} else {
return and__4221__auto__;
}
})();
if(cljs.core.truth_(temp__5751__auto__)){
var change = temp__5751__auto__;
var array80382 = changes;
array80382.push(change);

return array80382;
} else {
return changes;
}
})();
var G__80703 = (from_pos + ((value).length));
var G__80704 = (function (){var G__80383 = line_num;
if(cljs.core.truth_(lineBreak)){
return (G__80383 + (1));
} else {
return G__80383;
}
})();
result = G__80701;
changes = G__80702;
from_pos = G__80703;
line_num = G__80704;
continue;
}
break;
}
}));

(nextjournal.clojure_mode.util.update_lines.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(nextjournal.clojure_mode.util.update_lines.cljs$lang$applyTo = (function (seq80340){
var G__80341 = cljs.core.first(seq80340);
var seq80340__$1 = cljs.core.next(seq80340);
var G__80342 = cljs.core.first(seq80340__$1);
var seq80340__$2 = cljs.core.next(seq80340__$1);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__80341,G__80342,seq80340__$2);
}));

/**
 * `f` will be called for each selected line with args [line, changes-array, range]
 * and should *mutate* changes-array
 */
nextjournal.clojure_mode.util.update_selected_lines = (function nextjournal$clojure_mode$util$update_selected_lines(state,f){
var at_line = cljs.core.atom.cljs$core$IFn$_invoke$arity$1((-1));
var doc = state.doc;
return state.changeByRange((function (p__80389){
var map__80392 = p__80389;
var map__80392__$1 = (((((!((map__80392 == null))))?(((((map__80392.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80392.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80392):map__80392);
var range = map__80392__$1;
var from = (function (){var obj80396 = map__80392__$1;
var k80397 = "from";
if((function (){var obj80398 = obj80396;
return (((!((obj80398 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80397,obj80398)));
})()){
return (obj80396[k80397]);
} else {
return undefined;
}
})();
var to = (function (){var obj80400 = map__80392__$1;
var k80401 = "to";
if((function (){var obj80402 = obj80400;
return (((!((obj80402 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80401,obj80402)));
})()){
return (obj80400[k80401]);
} else {
return undefined;
}
})();
var anchor = (function (){var obj80403 = map__80392__$1;
var k80404 = "anchor";
if((function (){var obj80405 = obj80403;
return (((!((obj80405 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80404,obj80405)));
})()){
return (obj80403[k80404]);
} else {
return undefined;
}
})();
var head = (function (){var obj80406 = map__80392__$1;
var k80407 = "head";
if((function (){var obj80408 = obj80406;
return (((!((obj80408 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80407,obj80408)));
})()){
return (obj80406[k80407]);
} else {
return undefined;
}
})();
var changes = [];
var line = doc.lineAt(from);
while(true){
var map__80420 = line;
var map__80420__$1 = (((((!((map__80420 == null))))?(((((map__80420.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80420.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80420):map__80420);
var line_number = (function (){var obj80422 = map__80420__$1;
var k80423 = "number";
if((function (){var obj80424 = obj80422;
return (((!((obj80424 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80423,obj80424)));
})()){
return (obj80422[k80423]);
} else {
return undefined;
}
})();
var line_to = (function (){var obj80425 = map__80420__$1;
var k80426 = "to";
if((function (){var obj80427 = obj80425;
return (((!((obj80427 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80426,obj80427)));
})()){
return (obj80425[k80426]);
} else {
return undefined;
}
})();
if((line.number > cljs.core.deref(at_line))){
cljs.core.reset_BANG_(at_line,line_number);

(f.cljs$core$IFn$_invoke$arity$3 ? f.cljs$core$IFn$_invoke$arity$3(line,changes,range) : f.call(null,line,changes,range));
} else {
}

var temp__5751__auto__ = (function (){var and__4221__auto__ = (to > line_to);
if(and__4221__auto__){
return nextjournal.clojure_mode.util.guard(doc.lineAt((line_to + (1))),((function (line,and__4221__auto__,map__80420,map__80420__$1,line_number,line_to,changes,map__80392,map__80392__$1,range,from,to,anchor,head,at_line,doc){
return (function (p1__80385_SHARP_){
return (p1__80385_SHARP_.number > line_number);
});})(line,and__4221__auto__,map__80420,map__80420__$1,line_number,line_to,changes,map__80392,map__80392__$1,range,from,to,anchor,head,at_line,doc))
);
} else {
return and__4221__auto__;
}
})();
if(cljs.core.truth_(temp__5751__auto__)){
var next_line = temp__5751__auto__;
var G__80705 = next_line;
line = G__80705;
continue;
} else {
var change_set = state.changes(changes);
return ({"changes": changes, "range": module$node_modules$$codemirror$state$dist$index_cjs.EditorSelection.range(change_set.mapPos(anchor,(1)),change_set.mapPos(head,(1)))});
}
break;
}
}));
});
/**
 * `f` will be called for each changed line with args [line, changes-array]
 * and should *mutate* changes-array. Selections will be mapped through the resulting changeset.
 */
nextjournal.clojure_mode.util.iter_changed_lines = (function nextjournal$clojure_mode$util$iter_changed_lines(p__80432,f){
var map__80436 = p__80432;
var map__80436__$1 = (((((!((map__80436 == null))))?(((((map__80436.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80436.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80436):map__80436);
var tr = map__80436__$1;
var map__80438 = (function (){var obj80440 = map__80436__$1;
var k80441 = "state";
if((function (){var obj80442 = obj80440;
return (((!((obj80442 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80441,obj80442)));
})()){
return (obj80440[k80441]);
} else {
return undefined;
}
})();
var map__80438__$1 = (((((!((map__80438 == null))))?(((((map__80438.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80438.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80438):map__80438);
var state = map__80438__$1;
var doc = (function (){var obj80444 = map__80438__$1;
var k80445 = "doc";
if((function (){var obj80447 = obj80444;
return (((!((obj80447 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80445,obj80447)));
})()){
return (obj80444[k80445]);
} else {
return undefined;
}
})();
var changes = (function (){var obj80449 = map__80436__$1;
var k80450 = "changes";
if((function (){var obj80451 = obj80449;
return (((!((obj80451 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80450,obj80451)));
})()){
return (obj80449[k80450]);
} else {
return undefined;
}
})();
var effects = (function (){var obj80452 = map__80436__$1;
var k80453 = "effects";
if((function (){var obj80454 = obj80452;
return (((!((obj80454 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80453,obj80454)));
})()){
return (obj80452[k80453]);
} else {
return undefined;
}
})();
var selection = (function (){var obj80455 = map__80436__$1;
var k80456 = "selection";
if((function (){var obj80457 = obj80455;
return (((!((obj80457 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80456,obj80457)));
})()){
return (obj80455[k80456]);
} else {
return undefined;
}
})();
var at_line = cljs.core.atom.cljs$core$IFn$_invoke$arity$1((-1));
var next_changes = [];
var _ = changes.iterChanges((function (from_a,to_a,from_b,to_b,inserted){
var map__80458 = doc.lineAt(from_b);
var map__80458__$1 = (((((!((map__80458 == null))))?(((((map__80458.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80458.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80458):map__80458);
var line = map__80458__$1;
var line_number = (function (){var obj80462 = map__80458__$1;
var k80463 = "number";
if((function (){var obj80464 = obj80462;
return (((!((obj80464 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80463,obj80464)));
})()){
return (obj80462[k80463]);
} else {
return undefined;
}
})();
var line_to = (function (){var obj80465 = map__80458__$1;
var k80466 = "to";
if((function (){var obj80468 = obj80465;
return (((!((obj80468 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80466,obj80468)));
})()){
return (obj80465[k80466]);
} else {
return undefined;
}
})();
var line__$1 = line;
while(true){
if((line_number > cljs.core.deref(at_line))){
cljs.core.reset_BANG_(at_line,line_number);

(f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(line__$1,next_changes) : f.call(null,line__$1,next_changes));
} else {
}

if((to_b <= line_to)){
return null;
} else {
var next_line = doc.lineAt((line_to + (1)));
if(cljs.core.truth_((function (){var and__4221__auto__ = next_line;
if(cljs.core.truth_(and__4221__auto__)){
return (next_line.number > line__$1.number);
} else {
return and__4221__auto__;
}
})())){
var G__80706 = next_line;
line__$1 = G__80706;
continue;
} else {
return null;
}
}
break;
}
}));
var next_changeset = state.changes(next_changes);
if(cljs.core.seq(next_changes)){
var G__80478 = (function (){var obj80479 = (function (){var obj80480 = tr;
if((!((obj80480 == null)))){
var out80481 = ({});
var k__49400__auto___80707 = "annotations";
if(applied_science.js_interop.impl.in_QMARK__STAR_(k__49400__auto___80707,obj80480)){
var obj80487_80708 = out80481;
(obj80487_80708[k__49400__auto___80707] = (obj80480[k__49400__auto___80707]));

} else {
}

var k__49400__auto___80709 = "scrollIntoView";
if(applied_science.js_interop.impl.in_QMARK__STAR_(k__49400__auto___80709,obj80480)){
var obj80488_80710 = out80481;
(obj80488_80710[k__49400__auto___80709] = (obj80480[k__49400__auto___80709]));

} else {
}

var k__49400__auto___80711 = "reconfigure";
if(applied_science.js_interop.impl.in_QMARK__STAR_(k__49400__auto___80711,obj80480)){
var obj80489_80712 = out80481;
(obj80489_80712[k__49400__auto___80711] = (obj80480[k__49400__auto___80711]));

} else {
}

return out80481;
} else {
return ({});
}
})();
var obj80494 = (((!((obj80479 == null))))?obj80479:({}));
(obj80494["changes"] = changes.compose(next_changeset));

return obj80494;
})();
var G__80478__$1 = (cljs.core.truth_(selection)?(function (){var obj80587 = G__80478;
var obj80589 = (((!((obj80587 == null))))?obj80587:({}));
(obj80589["selection"] = state.selection.map(next_changeset));

return obj80589;
})():G__80478);
if(cljs.core.truth_(effects)){
var obj80594 = G__80478__$1;
var obj80599 = (((!((obj80594 == null))))?obj80594:({}));
(obj80599["effects"] = module$node_modules$$codemirror$state$dist$index_cjs.StateEffect.mapEffects(effects,next_changeset));

return obj80599;
} else {
return G__80478__$1;
}
} else {
return tr;
}
});
nextjournal.clojure_mode.util.something_selected_QMARK_ = (function nextjournal$clojure_mode$util$something_selected_QMARK_(p__80630){
var map__80644 = p__80630;
var map__80644__$1 = (((((!((map__80644 == null))))?(((((map__80644.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80644.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80644):map__80644);
var map__80646 = (function (){var obj80660 = map__80644__$1;
var k80661 = "selection";
if((function (){var obj80670 = obj80660;
return (((!((obj80670 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80661,obj80670)));
})()){
return (obj80660[k80661]);
} else {
return undefined;
}
})();
var map__80646__$1 = (((((!((map__80646 == null))))?(((((map__80646.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80646.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80646):map__80646);
var ranges = (function (){var obj80680 = map__80646__$1;
var k80681 = "ranges";
if((function (){var obj80682 = obj80680;
return (((!((obj80682 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80681,obj80682)));
})()){
return (obj80680[k80681]);
} else {
return undefined;
}
})();
return (!(cljs.core.every_QMARK_((function (p1__80627_SHARP_){
return p1__80627_SHARP_.empty;
}),ranges)));
});
nextjournal.clojure_mode.util.range_str = (function nextjournal$clojure_mode$util$range_str(state,p__80683){
var map__80684 = p__80683;
var map__80684__$1 = (((((!((map__80684 == null))))?(((((map__80684.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__80684.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__80684):map__80684);
var selection = map__80684__$1;
var from = (function (){var obj80686 = map__80684__$1;
var k80687 = "from";
if((function (){var obj80688 = obj80686;
return (((!((obj80688 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80687,obj80688)));
})()){
return (obj80686[k80687]);
} else {
return undefined;
}
})();
var to = (function (){var obj80689 = map__80684__$1;
var k80690 = "to";
if((function (){var obj80691 = obj80689;
return (((!((obj80691 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k80690,obj80691)));
})()){
return (obj80689[k80690]);
} else {
return undefined;
}
})();
return cljs.core.str.cljs$core$IFn$_invoke$arity$1((function (){var parent__49521__auto__ = (state["doc"]);
var f__49522__auto__ = (parent__49521__auto__["slice"]);
return f__49522__auto__.call(parent__49521__auto__,from,to);
})());
});

//# sourceMappingURL=nextjournal.clojure_mode.util.js.map
